/*	
 *	frams3m.c
 *
 *	P/ECE S3M Driver
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2004 Naoyuki Sawa
 *
 *	* Tue Nov 14 20:03:00 JST 2004 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "clip.h"

/* * G[R[h̒ĺAsԍ𕉒lɂ̂łB
 *   vOCƁAG[R[hς\܂B
 *   G[R[h̒ĺAfobÔ߂ɗpĂB
 */
#define ERRNO	(-__LINE__)

/****************************************************************************
 *	P/ECE S3M Driver
 ****************************************************************************/

int
s3m_run(S3MDRIVER* driver)
{
	int flags;
	int note;
	int octave;
	int period;
	int instrument;
	int volume;
	int special_command;
	int command_info;
	int i_pattern;
	int i_channel;
	S3MCHANNEL* channel;
	S3MSAMPLE* sample;

	if(driver->stat) goto L_EXIT;

	/* 1[Tick]̎Ԍo߂JEgAbv܂B
	 * Tempo̐ݒl125̏ꍇɁA1[Tick]=1/50[Sec]ƂȂ܂B
	 */
	driver->progress += driver->tempo;
	while(driver->progress >= 125) {
		driver->progress -= 125;

		/* 1[Tick]o߂܂B
		 * oTickSpeed̐ݒlɒBA1[Row]i݂܂B
		 */
		driver->tick++;
		while(driver->tick >= driver->speed) {
			driver->tick -= driver->speed;

			/* Position jumpvĂ... */
			if(driver->position_jump != -1) {

				/* Orderݒ肵܂B */
				driver->order = driver->position_jump;
				if((driver->order < 0) ||
				   (driver->order > driver->ordnum - 1)) {
					driver->stat = ERRNO; /* Position jumps */
					goto L_EXIT;
				}
				driver->row = 0; /* Kv!! */

				/* Pattern擾܂B(254=SkipΉ) */
				i_pattern = driver->orders[driver->order];
				if((i_pattern < 0) ||
				   (i_pattern > driver->patnum - 1)) {
					driver->stat = ERRNO; /* Patterns */
					goto L_EXIT;
				}
				driver->pattern_position = driver->patterns[i_pattern];

				/* Position jump܂B */
				driver->position_jump = -1;
			}

			/* Pattern breakvĂ邩A܂PatternI... */
			if((driver->pattern_break != -1) ||
			   (driver->row >= 64)) {

				/* Order̐擪Row֐i߂܂B */
				driver->order++;
				driver->row = 0;

				/* SongIo܂B
				 * * S3Mɂ́AMODXMɂ悤ȁASongI[ł̃[v䂪܂B
				 *   [vSongɂ́AIPosition jumpݒKvłB
				 */
				if(driver->order >= driver->ordnum) {
					driver->stat = ERRNO;
					goto L_EXIT;
				}

				/* Pattern擾܂B(254=SkipΉ) */
				i_pattern = driver->orders[driver->order];
				if((i_pattern < 0) ||
				   (i_pattern > driver->patnum - 1)) {
					driver->stat = ERRNO; /* Patterns */
					goto L_EXIT;
				}
				driver->pattern_position = driver->patterns[i_pattern];

				/* Pattern breakvĂ... */
				if(driver->pattern_break != -1) {

					/* Pattern breakɂĎw肳ꂽRow܂Ői߂܂B */
					if((driver->pattern_break < 0) ||
					   (driver->pattern_break > 64 - 1)) {
						driver->stat = ERRNO; /* Pattern breaks */
						goto L_EXIT;
					}
					while(driver->row < driver->pattern_break) {
						for(;;) {
							flags = *driver->pattern_position++;
							if(!flags) break; /* end of row */
							if(flags & 0x20) driver->pattern_position += 2; /* note, instrument */
							if(flags & 0x40) driver->pattern_position += 1; /* volume */
							if(flags & 0x80) driver->pattern_position += 2; /* special_command, command_info */
						}
						driver->row++;
					}

					/* Pattern break܂B */
					driver->pattern_break = -1;
				}
			}

			/* ̂߂ɁARowi߂Ă܂B */
			driver->row++;

			/* ܂AmSpecial command܂B */
			for(i_channel = 0, channel = driver->channels;
			    i_channel < 32;
			    i_channel++, channel++) {
				channel->special_command = 0; /*  */
			}

			/* 1[Row]Pattern data܂B */
			for(;;) {
				flags = *driver->pattern_position++;
				if(!flags) break; /* end of row */
				if(flags & 0x20) {
					note = *driver->pattern_position++;
					instrument = *driver->pattern_position++;
				} else {
					note = 0;
					instrument = 0;
				}
				if(flags & 0x40) {
					volume = *driver->pattern_position++;
				} else {
					volume = -1; /* Volume=0͗LlȂ̂ŁA-1ƂĂ܂ */
				}
				if(flags & 0x80) {
					special_command = *driver->pattern_position++;
					command_info = *driver->pattern_position++;
				} else {
					special_command = 0;
					command_info = 0;
				}

				/* * S3Mt@Cł͋HɁAChannelɑ΂锭vĂ݂łB(2ND_PM.S3M)
				 *   G[2ND_PM.S3MtłȂȂ邽߁A邱Ƃɂ܂B
				 */
				i_channel = flags & 0x1f;
				channel = &driver->channels[i_channel];
				if(channel->pending_sample) { /* ChannelL? */

					/* Instruments܂B */
					if(instrument) {
						if((instrument >= 1) &&
						   (instrument <= driver->insnum)) {
							sample = &driver->samples[instrument - 1/*YȂ!!*/];
							if(sample->sampledata) { /* SampleL? */
								channel->pending_sample = sample;
								channel->vol = sample->vol; /* VolumeKey onɓKp܂!! */
							}
						}
					}

					/* Notes܂B */
					if(note) {
						switch(note) {
						case 255: /* empty note */
							/** no job **/
							break;
						case 254: /* key off */
							channel->playing_sample = NULL;
							break;
						default: /* key on */
							octave = note >> 4;
							note &= 15;
							if(note < 12) { /* 0=C,1=C#,..,10=A#,11=B */
								sample = channel->pending_sample;
								if(sample->sampledata) { /* SampleL? */
								      //period = ((8363 << 4) * (s3m_note_frequency_table[note] >> octave)) / sample->c2spd;
								      //xUp̂ߎό`
									period = ((8363 << 4) * (s3m_note_frequency_table[note]) >> octave) / sample->c2spd;
									if((special_command ==  7) ||	/* Gxy Tone portamento */
									   (special_command == 12)) {	/* Lxy Volslide+Toneporta */
										channel->tone_portamento = period;
										/* Tone portamentoƕpāuInstrumentƈقȂInstrumentݒ肷vƁA
										 * gKƂȂ悤łB(ModplugTrackerŊmF) ̐U镑͖łB
										 */
									} else {
										channel->playing_sample = sample;
										channel->sample_position = sample->sampledata;
										channel->period = period;
										channel->progress = 0;
										/* VolumeInstrumentŝƂœKpĂ܂!! */
									}
								}
							}
							break;
						}
					}

					/* Volumes܂B
					 *   0x00..0x40: Set volume
					 *   0x80..0xc0: Set panning (Ή)
					 */
					if((volume >= 0x00) &&
					   (volume <= 0x40)) {
						channel->vol = volume;
					}

					/* Special commandi[܂B */
					if(special_command) {
						channel->special_command = special_command;
						if(command_info) {
							channel->command_info = command_info;
						} else {
							/* Command info0̏ꍇAꕔSpecial command͑Olp܂B
							 * ȉswitch`caseŁARgAEgā@遚Special command́AOlp܂B
							 *                       RgAEgāȂSpecial command́A0i[܂B
							 * ǂSpecial commandOlpDocumentɖLĂȂ̂ŁAƎfłB
							 */
							switch(special_command) {
							case  1: /* Axy Set speed */
							case  2: /* Bxy Position jump */
							case  3: /* Cxy Pattern break */
							//case  4: /* Dxy Volume slide */
							//case  5: /* Exy Portamento down */
							//case  6: /* Fxy Portamento up */
							//case  7: /* Gxy Tone portamento */
							//case  8: /* Hxy Vibrato */
							//case  9: /* Ixy Tremor */
							//case 10: /* Jxy Arpeggio */
							//case 11: /* Kxy Volslide+Vibrato */
							//case 12: /* Lxy Volslide+Toneporta */
							//case 13: /* Mxy Set channel volume */
							//case 14: /* Nxy Channel volslide */
							//case 15: /* Oxy Set offset */
							//case 16: /* Pxy Panning slide */
							//case 17: /* Qxy Retrigger note */
							//case 18: /* Rxy Tremolo */
							//case 19: /* Sxy Extended S3M commands */ /* Ή */
							case 20: /* Txy Set tempo */
							//case 21: /* Uxy Fine vibrato */
							case 22: /* Vxy Set global volume */
							//case 23: /* Wxy Global volume slide */
							//case 24: /* Xxy Set panning */
							//case 25: /* Yxy Panbrello */
							//case 26: /* Zxy Midi macro */
								channel->command_info = command_info;
								break;
							}
						}
					}
				}
			}
		}

		/* e`lɂ... */
		for(i_channel = 0, channel = driver->channels;
		    i_channel < 32;
		    i_channel++, channel++) {

			/* ChannelȂΔ΂܂B */
			if(!channel->pending_sample) continue;

			/* Special commandLȂ΁As܂B */
			special_command = channel->special_command; /* o */
			if(special_command) {
				command_info = channel->command_info;
				switch(special_command) {
				case  1: /* Axy Set speed */
					driver->speed = command_info;
					special_command = 0; /*  */
					break;
				case  2: /* Bxy Position jump */
					driver->position_jump = command_info;
					special_command = 0; /*  */
					break;
				case  3: /* Cxy Pattern break */
					driver->pattern_break = command_info;
					special_command = 0; /*  */
					break;
VOLUME_SLIDE:			case  4: /* Dxy Volume slide */
					if(driver->tick) { /* Row̍ŏFrameł͕ωȂ */
						       if((command_info & 0xf0) == 0x00) { /* D0x Volume slide down */
							channel->vol -= command_info & 15;
							if(channel->vol < 0) {
								channel->vol = 0;
								special_command = 0; /*  */
							}
						} else if((command_info & 0x0f) == 0x00) { /* Dx0 Volume slide up */
							channel->vol += command_info >> 4;
							if(channel->vol > 64) {
								channel->vol = 64;
								special_command = 0; /*  */
							}
						} else if((command_info & 0xf0) == 0xf0) { /* DFx Fine volume slide down */
							channel->vol -= command_info & 15;
							if(channel->vol < 0) {
								channel->vol = 0;
							}
							special_command = 0; /*  */
						} else if((command_info & 0x0f) == 0x0f) { /* DxF Fine volume slide up */
							channel->vol += command_info >> 4;
							if(channel->vol > 64) {
								channel->vol = 64;
							}
							special_command = 0; /*  */
						}
					}
					break;
				case  5: /* Exy Portamento down */
					if(driver->tick) { /* Row̍ŏFrameł͕ωȂ */
						switch(command_info & 0xf0) {
						case 0xe0: /* EEx Extra fine portamento down */
							channel->period += command_info;
							if(channel->period > 14317056) { /* Ǝf */
								channel->period = 14317056;
							}
							special_command = 0; /*  */
							break;
						case 0xf0: /* EFx Fine portamento down */
							channel->period += command_info << 2;
							if(channel->period > 14317056) { /* Ǝf */
								channel->period = 14317056;
							}
							special_command = 0; /*  */
							break;
						default:   /* Exy Portamento down */
							channel->period += command_info << 2;
							if(channel->period > 14317056) { /* Ǝf */
								channel->period = 14317056;
								special_command = 0; /*  */
							}
							break;
						}
					}
					break;
				case  6: /* Fxy Portamento up */
					if(driver->tick) { /* Row̍ŏFrameł͕ωȂ */
						switch(command_info & 0xf0) {
						case 0xe0: /* FEx Extra fine portamento up */
							channel->period -= command_info;
							if(channel->period < 14317056 / 48000) { /* Ǝf */
								channel->period = 14317056 / 48000;
							}
							special_command = 0; /*  */
							break;
						case 0xf0: /* FFx Fine portamento up */
							channel->period -= command_info << 2;
							if(channel->period < 14317056 / 48000) { /* Ǝf */
								channel->period = 14317056 / 48000;
							}
							special_command = 0; /*  */
							break;
						default:   /* Fxy Portamento up */
							channel->period -= command_info << 2;
							if(channel->period < 14317056 / 48000) { /* Ǝf */
								channel->period = 14317056 / 48000;
								special_command = 0; /*  */
							}
							break;
						}
					}
					break;
				case  7: /* Gxy Tone portamento */
					/* Row̍ŏFrameω邩ۂsBԂωH Ǝf */
					       if(channel->period < channel->tone_portamento) {
						channel->period += command_info << 2;
						if(channel->period >= channel->tone_portamento) {
							channel->period = channel->tone_portamento;
							special_command = 0; /*  */
						}
					} else if(channel->period > channel->tone_portamento) {
						channel->period -= command_info << 2;
						if(channel->period <= channel->tone_portamento) {
							channel->period = channel->tone_portamento;
							special_command = 0; /*  */
						}
					}
					break;
				//case  8: /* Hxy Vibrato */
				//case  9: /* Ixy Tremor */
				//case 10: /* Jxy Arpeggio */
				case 11: /* Kxy Volslide+Vibrato */
					/* Vibrato͖Ή */
					goto VOLUME_SLIDE;
					break;
				case 12: /* Lxy Volslide+Toneporta */
					/* Tone portamento͖Ή */
					goto VOLUME_SLIDE;
					break;
				//case 13: /* Mxy Set channel volume */
				//case 14: /* Nxy Channel volslide */
				//case 15: /* Oxy Set offset */
				//case 16: /* Pxy Panning slide */
				//case 17: /* Qxy Retrigger note */
				//case 18: /* Rxy Tremolo */
				//case 19: /* Sxy Extended S3M commands */
				case 20: /* Txy Set tempo */
					driver->tempo = command_info;
					special_command = 0; /*  */
					break;
				//case 21: /* Uxy Fine vibrato */
				case 22: /* Vxy Set global volume */
					driver->g_v = command_info;
					special_command = 0; /*  */
					break;
				case 23: /* Wxy Global volume slide */
					if(driver->tick) { /* Row̍ŏFrameł͕ωȂ */
						       if((command_info & 0xf0) == 0x00) { /* W0x Global volume slide down */
							driver->g_v -= command_info & 15;
							if(driver->g_v < 0) {
								driver->g_v = 0;
								special_command = 0; /*  */
							}
						} else if((command_info & 0x0f) == 0x00) { /* Wx0 Global volume slide up */
							driver->g_v += command_info >> 4;
							if(driver->g_v > 64) {
								driver->g_v = 64;
								special_command = 0; /*  */
							}
						} else if((command_info & 0xf0) == 0xf0) { /* WFx Fine global volume slide down */
							driver->g_v -= command_info & 15;
							if(driver->g_v < 0) {
								driver->g_v = 0;
							}
							special_command = 0; /*  */
						} else if((command_info & 0x0f) == 0x0f) { /* WxF Fine global volume slide up */
							driver->g_v += command_info >> 4;
							if(driver->g_v > 64) {
								driver->g_v = 64;
							}
							special_command = 0; /*  */
						}
					}
					break;
				//case 24: /* Xxy Set panning */
				//case 25: /* Yxy Panbrello */
				//case 26: /* Zxy Midi macro */
				}
				channel->special_command = special_command; /* ߂ */
			}
		}
	}

L_EXIT:
	return driver->stat;
}

int
s3m_mix(S3MDRIVER* driver, short wbuff[/*S3MBUFLEN*/])
{
	static int mixbuf[S3MBUFLEN]; /* ~LVOobt@Ars`shbłI */
	//
	int i;
	int i_channel;
	int frequency;
	int progress;
	int volume;
	int output;
	S3MCHANNEL* channel;
	S3MSAMPLE* sample;
	const unsigned char* sample_position;
	const unsigned char* loop_begin;
	const unsigned char* loop_end;
	int* p;

	if(driver->stat) goto L_EXIT;

	/* ܂A~LVOobt@NA܂B */
	memset(mixbuf, 0, sizeof mixbuf);

	/* e`lɂ... */
	for(i_channel = 0, channel = driver->channels;
	    i_channel < 32;
	    i_channel++, channel++) {

		/* SilentȂΔ΂܂B
		 * Channel͕KSilentێĂ̂ŁAChannelۂ̔f͕svłB
		 */
		sample = channel->playing_sample;
		if(!sample) continue;

		/* ̂߁A悭gtB[hoĂ܂B
		 * ̃tB[h́AƂŏ߂Kv܂B
		 */
		sample_position = channel->sample_position;
		progress = channel->progress;

		/* {[߂܂B */
		volume = driver->g_v *	/*   0..64 ( 6bit) */
			 channel->vol;	/* x 0..64 ( 6bit) */
					/* =       (12bit) */
		if(!volume) continue; /*  */

		/* Đg߂܂B */
		frequency = 14317056 / channel->period;

		/* 1[Tick]~LVO܂B */
		loop_begin = sample->loop_begin;
		loop_end = sample->loop_end;
		for(i = 0, p = mixbuf; i < S3MBUFLEN; i++, p++) {
			progress += frequency;
			while(progress >= SPEAKER_FREQUENCY) {
				progress -= SPEAKER_FREQUENCY;
				sample_position++;
				if(sample_position >= loop_end) {
					if(!loop_begin) { /* Loop off */
						channel->playing_sample = NULL;
						goto L_NEXT;
					}
					sample_position = loop_begin;
				}
			}
			*p += (*sample_position - 0x80) * volume;
		}
L_NEXT:
		/* otB[h߂܂B */
		channel->sample_position = sample_position;
		channel->progress = progress;
	}

	/* ~LVOobt@NbsOāAo̓obt@֏݂܂B */
	for(i = 0, p = mixbuf; i < S3MBUFLEN; i++, p++, wbuff++) {
		/*   volume (12bit)
		 * x sample ( 8bit)
		 * x 32[ch] ( 5bit)
		 * =        (25bit)
		 */
		output = *p >> ((25 - 16) - 4/**/);
		if(output < -32767) output = -32767;
		if(output >  32767) output =  32767;
		*wbuff = output;
	}

L_EXIT:
	return driver->stat;
}

